#pragma once

// This sample is writen in C++ CLI for Dot Net It uses the Class Library dll written in C#

#include <string>

namespace Sample1 {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	using namespace System::Runtime::InteropServices; // for passing refferenced CLR objects to the dll

	using namespace AIOUSBNet;  // the namespace exposes the AIOUSB Class interface 

	/// <summary>
	/// Summary for Form1
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form
	{

	// My variables:
	public: 
		// One and only Device Index etc:
		static unsigned int DeviceIndex = AIOUSB::diOnly; 		// Initialize default Device Only:
		static int numPins = 32;
		static int numPorts = 32;
		static int numCounters = 0;
        
		// State flags:
		static bool* bModeInOut = new bool[32];

		// For bitmasks:
        static unsigned int OutMask = 0;  // 32 bits // all bits to 0 means all ports not output hence input
        static unsigned int Data = 0;  // 32 bits

		// Array of controls for GUI updates:
		public: static cli::array<Button^>^ toggleBtnArray = gcnew cli::array<Button^>(32);
		public: static cli::array<CheckBox^>^ checkStateArray = gcnew cli::array<CheckBox^>(32);

		// Interval Timer fou GUI update:
        // (Note: A Windows Forms timer designed for single threaded environments not a System Timer 55 ms min res)
        static System::Windows::Forms::Timer^ myTimer = gcnew System::Windows::Forms::Timer;
		static int alarmCounter = 1;
		static bool exitFlag = false;

	public:
		Form1(void)
		{
			InitializeComponent();
			//
			//TODO: Add the constructor code here
			//
			
			for(int i=0; i < 32; i++)
			{
				bModeInOut[i] = false;
			}

			// Array of the toggle mode buttons:
            toggleBtnArray[0] = btnToggle0;
            toggleBtnArray[1] = btnToggle1;
            toggleBtnArray[2] = btnToggle2;
            toggleBtnArray[3] = btnToggle3;
            toggleBtnArray[4] = btnToggle4;
            toggleBtnArray[5] = btnToggle5;
            toggleBtnArray[6] = btnToggle6;
            toggleBtnArray[7] = btnToggle7;

            toggleBtnArray[8] = btnToggle8;
            toggleBtnArray[9] = btnToggle9;
            toggleBtnArray[10] = btnToggle10;
            toggleBtnArray[11] = btnToggle11;
            toggleBtnArray[12] = btnToggle12;
            toggleBtnArray[13] = btnToggle13;
            toggleBtnArray[14] = btnToggle14;
            toggleBtnArray[15] = btnToggle15;
            
            toggleBtnArray[16] = btnToggle16;
            toggleBtnArray[17] = btnToggle17;
            toggleBtnArray[18] = btnToggle18;
            toggleBtnArray[19] = btnToggle19;
            toggleBtnArray[20] = btnToggle20;
            toggleBtnArray[21] = btnToggle21;
            toggleBtnArray[22] = btnToggle22;
            toggleBtnArray[23] = btnToggle23;

            toggleBtnArray[24] = btnToggle24;
            toggleBtnArray[25] = btnToggle25;
            toggleBtnArray[26] = btnToggle26;
            toggleBtnArray[27] = btnToggle27;
            toggleBtnArray[28] = btnToggle28;
            toggleBtnArray[29] = btnToggle29;
            toggleBtnArray[30] = btnToggle30;
            toggleBtnArray[31] = btnToggle31;


            // Array of the LED style checkboxes:
            checkStateArray[0] = checkBoxA0_1;
            checkStateArray[1] = checkBoxA0_2;
            checkStateArray[2] = checkBoxA0_3;
            checkStateArray[3] = checkBoxA0_4;
            checkStateArray[4] = checkBoxA0_5;
            checkStateArray[5] = checkBoxA0_6;
            checkStateArray[6] = checkBoxA0_7;
            checkStateArray[7] = checkBoxA0_8;

            checkStateArray[8] = checkBoxB0_9;
            checkStateArray[9] = checkBoxB0_10;
            checkStateArray[10] = checkBoxB0_11;
            checkStateArray[11] = checkBoxB0_12;
            checkStateArray[12] = checkBoxB0_13;
            checkStateArray[13] = checkBoxB0_14;
            checkStateArray[14] = checkBoxB0_15;
            checkStateArray[15] = checkBoxB0_16;
            
            checkStateArray[16] = checkBoxC0_17;
            checkStateArray[17] = checkBoxC0_18;
            checkStateArray[18] = checkBoxC0_19;
            checkStateArray[19] = checkBoxC0_20;
            checkStateArray[20] = checkBoxC0_21;
            checkStateArray[21] = checkBoxC0_22;
            checkStateArray[22] = checkBoxC0_23;
            checkStateArray[23] = checkBoxC0_24;

            checkStateArray[24] = checkBoxA1_25;
            checkStateArray[25] = checkBoxA1_26;
            checkStateArray[26] = checkBoxA1_27;
            checkStateArray[27] = checkBoxA1_28;
            checkStateArray[28] = checkBoxA1_29;
            checkStateArray[29] = checkBoxA1_30;
            checkStateArray[30] = checkBoxA1_31;
            checkStateArray[31] = checkBoxA1_32;

			// Configure board to a known default state:
			unsigned int Status = 0;
			unsigned int OutMask= 0x00000000;	// all bit to 0 mean all ports not output hence input
			unsigned int Data = 0xFFFFFFFF;		// all bits set
			unsigned char tristate = 0;			// always false for USB-DIO-32I

			unsigned int %rOutMask = OutMask;
			unsigned int %rData = Data;
            
			Status = AIOUSB::DIO_Configure(DeviceIndex, tristate, rOutMask, rData);
			
			// Adds the event and the event handler for the method that will 
            // process the timer event to the timer		
			myTimer->Tick += gcnew EventHandler( TimerEventProcessor );

			// Sets the timer interval in ms:
			myTimer->Interval = 100;
			myTimer->Start();
		}

	protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~Form1()
		{
			if (components)
			{
				delete components;
			}
		}
	private: System::Windows::Forms::Button^  btnToggle25;
	protected: 
	private: System::Windows::Forms::Button^  btnToggle26;
	private: System::Windows::Forms::CheckBox^  checkBox3;
	private: System::Windows::Forms::Button^  btnToggle24;
	private: System::Windows::Forms::Button^  btnToggle27;
	private: System::Windows::Forms::Button^  btnToggle28;
	private: System::Windows::Forms::Button^  btnToggle29;
	private: System::Windows::Forms::GroupBox^  groupBox2;
	private: System::Windows::Forms::Button^  btnToggle30;
	private: System::Windows::Forms::Button^  btnToggle31;
	private: System::Windows::Forms::Button^  btnToggle16;
	private: System::Windows::Forms::Button^  btnToggle17;
	private: System::Windows::Forms::Button^  btnToggle18;
	private: System::Windows::Forms::Button^  btnToggle19;
	private: System::Windows::Forms::Button^  btnToggle20;
	private: System::Windows::Forms::Button^  btnToggle21;
	private: System::Windows::Forms::Button^  btnToggle22;
	private: System::Windows::Forms::Button^  btnToggle23;
	private: System::Windows::Forms::Button^  btnToggle8;
	private: System::Windows::Forms::Button^  btnToggle9;
	private: System::Windows::Forms::Button^  btnToggle10;
	private: System::Windows::Forms::Button^  btnToggle11;
	private: System::Windows::Forms::Button^  btnToggle12;
	private: System::Windows::Forms::Button^  btnToggle13;
	private: System::Windows::Forms::Button^  btnToggle14;
	private: System::Windows::Forms::Button^  btnToggle0;
	private: System::Windows::Forms::Button^  btnToggle1;
	private: System::Windows::Forms::Button^  btnToggle2;
	private: System::Windows::Forms::Button^  btnToggle3;
	private: System::Windows::Forms::Button^  btnToggle4;
	private: System::Windows::Forms::Button^  btnToggle5;
	private: System::Windows::Forms::Button^  btnToggle6;
	private: System::Windows::Forms::Label^  label12;
	private: System::Windows::Forms::Label^  label7;
	private: System::Windows::Forms::Label^  label3;
	private: System::Windows::Forms::Label^  label1;
	private: System::Windows::Forms::Label^  label11;
	private: System::Windows::Forms::Label^  label10;
	private: System::Windows::Forms::Label^  label9;
	private: System::Windows::Forms::Label^  label2;
	private: System::Windows::Forms::CheckBox^  checkBoxC0_21;
	private: System::Windows::Forms::Label^  label15;
	private: System::Windows::Forms::CheckBox^  checkBoxC0_23;
	private: System::Windows::Forms::Button^  btnToggle15;
	private: System::Windows::Forms::CheckBox^  checkBoxC0_20;
	private: System::Windows::Forms::Label^  label14;
	private: System::Windows::Forms::CheckBox^  checkBoxC0_24;
	private: System::Windows::Forms::CheckBox^  checkBoxC0_22;
	private: System::Windows::Forms::Button^  btnToggle7;
	private: System::Windows::Forms::Label^  label4;
	private: System::Windows::Forms::CheckBox^  checkBoxC0_17;
	private: System::Windows::Forms::Label^  label13;
	private: System::Windows::Forms::CheckBox^  checkBoxA1_25;
	private: System::Windows::Forms::CheckBox^  checkBoxA0_8;
	private: System::Windows::Forms::CheckBox^  checkBoxA1_29;
	private: System::Windows::Forms::CheckBox^  checkBoxC0_18;
	private: System::Windows::Forms::CheckBox^  checkBoxA1_32;
	private: System::Windows::Forms::CheckBox^  checkBoxA1_28;
	private: System::Windows::Forms::CheckBox^  checkBoxA0_3;
	private: System::Windows::Forms::CheckBox^  checkBoxA1_26;
	private: System::Windows::Forms::CheckBox^  checkBoxA0_4;
	private: System::Windows::Forms::CheckBox^  checkBoxA1_27;
	private: System::Windows::Forms::CheckBox^  checkBoxC0_19;
	private: System::Windows::Forms::CheckBox^  checkBoxA0_2;
	private: System::Windows::Forms::CheckBox^  checkBoxA1_31;
	private: System::Windows::Forms::CheckBox^  checkBoxA0_5;
	private: System::Windows::Forms::CheckBox^  checkBoxA1_30;
	private: System::Windows::Forms::CheckBox^  checkBoxA0_1;
	private: System::Windows::Forms::CheckBox^  checkBoxA0_6;
	private: System::Windows::Forms::CheckBox^  checkBoxA0_7;
	private: System::Windows::Forms::CheckBox^  checkBoxB0_16;
	private: System::Windows::Forms::CheckBox^  checkBoxB0_14;
	private: System::Windows::Forms::CheckBox^  checkBoxB0_15;
	private: System::Windows::Forms::CheckBox^  checkBoxB0_11;
	private: System::Windows::Forms::CheckBox^  checkBoxB0_13;
	private: System::Windows::Forms::CheckBox^  checkBoxB0_10;
	private: System::Windows::Forms::CheckBox^  checkBoxB0_12;
	private: System::Windows::Forms::CheckBox^  checkBoxB0_9;
	private: System::Windows::Forms::Button^  btnDevice;
	private: System::Windows::Forms::CheckBox^  checkBox92;
	private: System::Windows::Forms::CheckBox^  checkBox91;
	private: System::Windows::Forms::GroupBox^  groupBox5;
	private: System::Windows::Forms::Label^  label5;
	private: System::Windows::Forms::CheckBox^  checkBox4;
	private: System::Windows::Forms::Label^  label6;
	private: System::Windows::Forms::Label^  label8;

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->btnToggle25 = (gcnew System::Windows::Forms::Button());
			this->btnToggle26 = (gcnew System::Windows::Forms::Button());
			this->checkBox3 = (gcnew System::Windows::Forms::CheckBox());
			this->btnToggle24 = (gcnew System::Windows::Forms::Button());
			this->btnToggle27 = (gcnew System::Windows::Forms::Button());
			this->btnToggle28 = (gcnew System::Windows::Forms::Button());
			this->btnToggle29 = (gcnew System::Windows::Forms::Button());
			this->groupBox2 = (gcnew System::Windows::Forms::GroupBox());
			this->btnToggle30 = (gcnew System::Windows::Forms::Button());
			this->btnToggle31 = (gcnew System::Windows::Forms::Button());
			this->btnToggle16 = (gcnew System::Windows::Forms::Button());
			this->btnToggle17 = (gcnew System::Windows::Forms::Button());
			this->btnToggle18 = (gcnew System::Windows::Forms::Button());
			this->btnToggle19 = (gcnew System::Windows::Forms::Button());
			this->btnToggle20 = (gcnew System::Windows::Forms::Button());
			this->btnToggle21 = (gcnew System::Windows::Forms::Button());
			this->btnToggle22 = (gcnew System::Windows::Forms::Button());
			this->btnToggle23 = (gcnew System::Windows::Forms::Button());
			this->btnToggle8 = (gcnew System::Windows::Forms::Button());
			this->btnToggle9 = (gcnew System::Windows::Forms::Button());
			this->btnToggle10 = (gcnew System::Windows::Forms::Button());
			this->btnToggle11 = (gcnew System::Windows::Forms::Button());
			this->btnToggle12 = (gcnew System::Windows::Forms::Button());
			this->btnToggle13 = (gcnew System::Windows::Forms::Button());
			this->btnToggle14 = (gcnew System::Windows::Forms::Button());
			this->btnToggle0 = (gcnew System::Windows::Forms::Button());
			this->btnToggle1 = (gcnew System::Windows::Forms::Button());
			this->btnToggle2 = (gcnew System::Windows::Forms::Button());
			this->btnToggle3 = (gcnew System::Windows::Forms::Button());
			this->btnToggle4 = (gcnew System::Windows::Forms::Button());
			this->btnToggle5 = (gcnew System::Windows::Forms::Button());
			this->btnToggle6 = (gcnew System::Windows::Forms::Button());
			this->label12 = (gcnew System::Windows::Forms::Label());
			this->label7 = (gcnew System::Windows::Forms::Label());
			this->label3 = (gcnew System::Windows::Forms::Label());
			this->label1 = (gcnew System::Windows::Forms::Label());
			this->label11 = (gcnew System::Windows::Forms::Label());
			this->label10 = (gcnew System::Windows::Forms::Label());
			this->label9 = (gcnew System::Windows::Forms::Label());
			this->label2 = (gcnew System::Windows::Forms::Label());
			this->checkBoxC0_21 = (gcnew System::Windows::Forms::CheckBox());
			this->label15 = (gcnew System::Windows::Forms::Label());
			this->checkBoxC0_23 = (gcnew System::Windows::Forms::CheckBox());
			this->btnToggle15 = (gcnew System::Windows::Forms::Button());
			this->checkBoxC0_20 = (gcnew System::Windows::Forms::CheckBox());
			this->label14 = (gcnew System::Windows::Forms::Label());
			this->checkBoxC0_24 = (gcnew System::Windows::Forms::CheckBox());
			this->checkBoxC0_22 = (gcnew System::Windows::Forms::CheckBox());
			this->btnToggle7 = (gcnew System::Windows::Forms::Button());
			this->label4 = (gcnew System::Windows::Forms::Label());
			this->checkBoxC0_17 = (gcnew System::Windows::Forms::CheckBox());
			this->label13 = (gcnew System::Windows::Forms::Label());
			this->checkBoxA1_25 = (gcnew System::Windows::Forms::CheckBox());
			this->checkBoxA0_8 = (gcnew System::Windows::Forms::CheckBox());
			this->checkBoxA1_29 = (gcnew System::Windows::Forms::CheckBox());
			this->checkBoxC0_18 = (gcnew System::Windows::Forms::CheckBox());
			this->checkBoxA1_32 = (gcnew System::Windows::Forms::CheckBox());
			this->checkBoxA1_28 = (gcnew System::Windows::Forms::CheckBox());
			this->checkBoxA0_3 = (gcnew System::Windows::Forms::CheckBox());
			this->checkBoxA1_26 = (gcnew System::Windows::Forms::CheckBox());
			this->checkBoxA0_4 = (gcnew System::Windows::Forms::CheckBox());
			this->checkBoxA1_27 = (gcnew System::Windows::Forms::CheckBox());
			this->checkBoxC0_19 = (gcnew System::Windows::Forms::CheckBox());
			this->checkBoxA0_2 = (gcnew System::Windows::Forms::CheckBox());
			this->checkBoxA1_31 = (gcnew System::Windows::Forms::CheckBox());
			this->checkBoxA0_5 = (gcnew System::Windows::Forms::CheckBox());
			this->checkBoxA1_30 = (gcnew System::Windows::Forms::CheckBox());
			this->checkBoxA0_1 = (gcnew System::Windows::Forms::CheckBox());
			this->checkBoxA0_6 = (gcnew System::Windows::Forms::CheckBox());
			this->checkBoxA0_7 = (gcnew System::Windows::Forms::CheckBox());
			this->checkBoxB0_16 = (gcnew System::Windows::Forms::CheckBox());
			this->checkBoxB0_14 = (gcnew System::Windows::Forms::CheckBox());
			this->checkBoxB0_15 = (gcnew System::Windows::Forms::CheckBox());
			this->checkBoxB0_11 = (gcnew System::Windows::Forms::CheckBox());
			this->checkBoxB0_13 = (gcnew System::Windows::Forms::CheckBox());
			this->checkBoxB0_10 = (gcnew System::Windows::Forms::CheckBox());
			this->checkBoxB0_12 = (gcnew System::Windows::Forms::CheckBox());
			this->checkBoxB0_9 = (gcnew System::Windows::Forms::CheckBox());
			this->btnDevice = (gcnew System::Windows::Forms::Button());
			this->checkBox92 = (gcnew System::Windows::Forms::CheckBox());
			this->checkBox91 = (gcnew System::Windows::Forms::CheckBox());
			this->groupBox5 = (gcnew System::Windows::Forms::GroupBox());
			this->label5 = (gcnew System::Windows::Forms::Label());
			this->checkBox4 = (gcnew System::Windows::Forms::CheckBox());
			this->label6 = (gcnew System::Windows::Forms::Label());
			this->label8 = (gcnew System::Windows::Forms::Label());
			this->groupBox2->SuspendLayout();
			this->groupBox5->SuspendLayout();
			this->SuspendLayout();
			// 
			// btnToggle25
			// 
			this->btnToggle25->Location = System::Drawing::Point(754, 168);
			this->btnToggle25->Name = L"btnToggle25";
			this->btnToggle25->Size = System::Drawing::Size(30, 23);
			this->btnToggle25->TabIndex = 153;
			this->btnToggle25->Tag = L"25";
			this->btnToggle25->Text = L"I";
			this->btnToggle25->UseVisualStyleBackColor = true;
			this->btnToggle25->Click += gcnew System::EventHandler(this, &Form1::btnToggle_Click);
			// 
			// btnToggle26
			// 
			this->btnToggle26->Location = System::Drawing::Point(723, 168);
			this->btnToggle26->Name = L"btnToggle26";
			this->btnToggle26->Size = System::Drawing::Size(30, 23);
			this->btnToggle26->TabIndex = 152;
			this->btnToggle26->Tag = L"26";
			this->btnToggle26->Text = L"I";
			this->btnToggle26->UseVisualStyleBackColor = true;
			this->btnToggle26->Click += gcnew System::EventHandler(this, &Form1::btnToggle_Click);
			// 
			// checkBox3
			// 
			this->checkBox3->Appearance = System::Windows::Forms::Appearance::Button;
			this->checkBox3->BackColor = System::Drawing::Color::Gray;
			this->checkBox3->Enabled = false;
			this->checkBox3->FlatAppearance->CheckedBackColor = System::Drawing::Color::Blue;
			this->checkBox3->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->checkBox3->Location = System::Drawing::Point(259, 12);
			this->checkBox3->Name = L"checkBox3";
			this->checkBox3->Size = System::Drawing::Size(29, 23);
			this->checkBox3->TabIndex = 3;
			this->checkBox3->Text = L"1";
			this->checkBox3->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->checkBox3->UseVisualStyleBackColor = false;
			// 
			// btnToggle24
			// 
			this->btnToggle24->Location = System::Drawing::Point(784, 168);
			this->btnToggle24->Name = L"btnToggle24";
			this->btnToggle24->Size = System::Drawing::Size(30, 23);
			this->btnToggle24->TabIndex = 154;
			this->btnToggle24->Tag = L"24";
			this->btnToggle24->Text = L"I";
			this->btnToggle24->UseVisualStyleBackColor = true;
			this->btnToggle24->Click += gcnew System::EventHandler(this, &Form1::btnToggle_Click);
			// 
			// btnToggle27
			// 
			this->btnToggle27->Location = System::Drawing::Point(692, 168);
			this->btnToggle27->Name = L"btnToggle27";
			this->btnToggle27->Size = System::Drawing::Size(30, 23);
			this->btnToggle27->TabIndex = 151;
			this->btnToggle27->Tag = L"27";
			this->btnToggle27->Text = L"I";
			this->btnToggle27->UseVisualStyleBackColor = true;
			this->btnToggle27->Click += gcnew System::EventHandler(this, &Form1::btnToggle_Click);
			// 
			// btnToggle28
			// 
			this->btnToggle28->Location = System::Drawing::Point(661, 168);
			this->btnToggle28->Name = L"btnToggle28";
			this->btnToggle28->Size = System::Drawing::Size(30, 23);
			this->btnToggle28->TabIndex = 150;
			this->btnToggle28->Tag = L"28";
			this->btnToggle28->Text = L"I";
			this->btnToggle28->UseVisualStyleBackColor = true;
			this->btnToggle28->Click += gcnew System::EventHandler(this, &Form1::btnToggle_Click);
			// 
			// btnToggle29
			// 
			this->btnToggle29->Location = System::Drawing::Point(630, 168);
			this->btnToggle29->Name = L"btnToggle29";
			this->btnToggle29->Size = System::Drawing::Size(30, 23);
			this->btnToggle29->TabIndex = 149;
			this->btnToggle29->Tag = L"29";
			this->btnToggle29->Text = L"I";
			this->btnToggle29->UseVisualStyleBackColor = true;
			this->btnToggle29->Click += gcnew System::EventHandler(this, &Form1::btnToggle_Click);
			// 
			// groupBox2
			// 
			this->groupBox2->Controls->Add(this->btnToggle24);
			this->groupBox2->Controls->Add(this->btnToggle25);
			this->groupBox2->Controls->Add(this->btnToggle26);
			this->groupBox2->Controls->Add(this->btnToggle27);
			this->groupBox2->Controls->Add(this->btnToggle28);
			this->groupBox2->Controls->Add(this->btnToggle29);
			this->groupBox2->Controls->Add(this->btnToggle30);
			this->groupBox2->Controls->Add(this->btnToggle31);
			this->groupBox2->Controls->Add(this->btnToggle16);
			this->groupBox2->Controls->Add(this->btnToggle17);
			this->groupBox2->Controls->Add(this->btnToggle18);
			this->groupBox2->Controls->Add(this->btnToggle19);
			this->groupBox2->Controls->Add(this->btnToggle20);
			this->groupBox2->Controls->Add(this->btnToggle21);
			this->groupBox2->Controls->Add(this->btnToggle22);
			this->groupBox2->Controls->Add(this->btnToggle23);
			this->groupBox2->Controls->Add(this->btnToggle8);
			this->groupBox2->Controls->Add(this->btnToggle9);
			this->groupBox2->Controls->Add(this->btnToggle10);
			this->groupBox2->Controls->Add(this->btnToggle11);
			this->groupBox2->Controls->Add(this->btnToggle12);
			this->groupBox2->Controls->Add(this->btnToggle13);
			this->groupBox2->Controls->Add(this->btnToggle14);
			this->groupBox2->Controls->Add(this->btnToggle0);
			this->groupBox2->Controls->Add(this->btnToggle1);
			this->groupBox2->Controls->Add(this->btnToggle2);
			this->groupBox2->Controls->Add(this->btnToggle3);
			this->groupBox2->Controls->Add(this->btnToggle4);
			this->groupBox2->Controls->Add(this->btnToggle5);
			this->groupBox2->Controls->Add(this->btnToggle6);
			this->groupBox2->Controls->Add(this->label12);
			this->groupBox2->Controls->Add(this->label7);
			this->groupBox2->Controls->Add(this->label3);
			this->groupBox2->Controls->Add(this->label1);
			this->groupBox2->Controls->Add(this->label11);
			this->groupBox2->Controls->Add(this->label10);
			this->groupBox2->Controls->Add(this->label9);
			this->groupBox2->Controls->Add(this->label2);
			this->groupBox2->Controls->Add(this->checkBoxC0_21);
			this->groupBox2->Controls->Add(this->label15);
			this->groupBox2->Controls->Add(this->checkBoxC0_23);
			this->groupBox2->Controls->Add(this->btnToggle15);
			this->groupBox2->Controls->Add(this->checkBoxC0_20);
			this->groupBox2->Controls->Add(this->label14);
			this->groupBox2->Controls->Add(this->checkBoxC0_24);
			this->groupBox2->Controls->Add(this->checkBoxC0_22);
			this->groupBox2->Controls->Add(this->btnToggle7);
			this->groupBox2->Controls->Add(this->label4);
			this->groupBox2->Controls->Add(this->checkBoxC0_17);
			this->groupBox2->Controls->Add(this->label13);
			this->groupBox2->Controls->Add(this->checkBoxA1_25);
			this->groupBox2->Controls->Add(this->checkBoxA0_8);
			this->groupBox2->Controls->Add(this->checkBoxA1_29);
			this->groupBox2->Controls->Add(this->checkBoxC0_18);
			this->groupBox2->Controls->Add(this->checkBoxA1_32);
			this->groupBox2->Controls->Add(this->checkBoxA1_28);
			this->groupBox2->Controls->Add(this->checkBoxA0_3);
			this->groupBox2->Controls->Add(this->checkBoxA1_26);
			this->groupBox2->Controls->Add(this->checkBoxA0_4);
			this->groupBox2->Controls->Add(this->checkBoxA1_27);
			this->groupBox2->Controls->Add(this->checkBoxC0_19);
			this->groupBox2->Controls->Add(this->checkBoxA0_2);
			this->groupBox2->Controls->Add(this->checkBoxA1_31);
			this->groupBox2->Controls->Add(this->checkBoxA0_5);
			this->groupBox2->Controls->Add(this->checkBoxA1_30);
			this->groupBox2->Controls->Add(this->checkBoxA0_1);
			this->groupBox2->Controls->Add(this->checkBoxA0_6);
			this->groupBox2->Controls->Add(this->checkBoxA0_7);
			this->groupBox2->Controls->Add(this->checkBoxB0_16);
			this->groupBox2->Controls->Add(this->checkBoxB0_14);
			this->groupBox2->Controls->Add(this->checkBoxB0_15);
			this->groupBox2->Controls->Add(this->checkBoxB0_11);
			this->groupBox2->Controls->Add(this->checkBoxB0_13);
			this->groupBox2->Controls->Add(this->checkBoxB0_10);
			this->groupBox2->Controls->Add(this->checkBoxB0_12);
			this->groupBox2->Controls->Add(this->checkBoxB0_9);
			this->groupBox2->Location = System::Drawing::Point(9, 16);
			this->groupBox2->Name = L"groupBox2";
			this->groupBox2->Size = System::Drawing::Size(828, 233);
			this->groupBox2->TabIndex = 126;
			this->groupBox2->TabStop = false;
			this->groupBox2->Text = L"I/O Ports";
			// 
			// btnToggle30
			// 
			this->btnToggle30->Location = System::Drawing::Point(599, 168);
			this->btnToggle30->Name = L"btnToggle30";
			this->btnToggle30->Size = System::Drawing::Size(30, 23);
			this->btnToggle30->TabIndex = 148;
			this->btnToggle30->Tag = L"30";
			this->btnToggle30->Text = L"I";
			this->btnToggle30->UseVisualStyleBackColor = true;
			this->btnToggle30->Click += gcnew System::EventHandler(this, &Form1::btnToggle_Click);
			// 
			// btnToggle31
			// 
			this->btnToggle31->Location = System::Drawing::Point(567, 168);
			this->btnToggle31->Name = L"btnToggle31";
			this->btnToggle31->Size = System::Drawing::Size(30, 23);
			this->btnToggle31->TabIndex = 147;
			this->btnToggle31->Tag = L"31";
			this->btnToggle31->Text = L"I";
			this->btnToggle31->UseVisualStyleBackColor = true;
			this->btnToggle31->Click += gcnew System::EventHandler(this, &Form1::btnToggle_Click);
			// 
			// btnToggle16
			// 
			this->btnToggle16->Location = System::Drawing::Point(364, 169);
			this->btnToggle16->Name = L"btnToggle16";
			this->btnToggle16->Size = System::Drawing::Size(30, 23);
			this->btnToggle16->TabIndex = 146;
			this->btnToggle16->Tag = L"16";
			this->btnToggle16->Text = L"I";
			this->btnToggle16->UseVisualStyleBackColor = true;
			this->btnToggle16->Click += gcnew System::EventHandler(this, &Form1::btnToggle_Click);
			// 
			// btnToggle17
			// 
			this->btnToggle17->Location = System::Drawing::Point(334, 169);
			this->btnToggle17->Name = L"btnToggle17";
			this->btnToggle17->Size = System::Drawing::Size(30, 23);
			this->btnToggle17->TabIndex = 145;
			this->btnToggle17->Tag = L"17";
			this->btnToggle17->Text = L"I";
			this->btnToggle17->UseVisualStyleBackColor = true;
			this->btnToggle17->Click += gcnew System::EventHandler(this, &Form1::btnToggle_Click);
			// 
			// btnToggle18
			// 
			this->btnToggle18->Location = System::Drawing::Point(303, 169);
			this->btnToggle18->Name = L"btnToggle18";
			this->btnToggle18->Size = System::Drawing::Size(30, 23);
			this->btnToggle18->TabIndex = 144;
			this->btnToggle18->Tag = L"18";
			this->btnToggle18->Text = L"I";
			this->btnToggle18->UseVisualStyleBackColor = true;
			this->btnToggle18->Click += gcnew System::EventHandler(this, &Form1::btnToggle_Click);
			// 
			// btnToggle19
			// 
			this->btnToggle19->Location = System::Drawing::Point(272, 169);
			this->btnToggle19->Name = L"btnToggle19";
			this->btnToggle19->Size = System::Drawing::Size(30, 23);
			this->btnToggle19->TabIndex = 143;
			this->btnToggle19->Tag = L"19";
			this->btnToggle19->Text = L"I";
			this->btnToggle19->UseVisualStyleBackColor = true;
			this->btnToggle19->Click += gcnew System::EventHandler(this, &Form1::btnToggle_Click);
			// 
			// btnToggle20
			// 
			this->btnToggle20->Location = System::Drawing::Point(241, 169);
			this->btnToggle20->Name = L"btnToggle20";
			this->btnToggle20->Size = System::Drawing::Size(30, 23);
			this->btnToggle20->TabIndex = 142;
			this->btnToggle20->Tag = L"20";
			this->btnToggle20->Text = L"I";
			this->btnToggle20->UseVisualStyleBackColor = true;
			this->btnToggle20->Click += gcnew System::EventHandler(this, &Form1::btnToggle_Click);
			// 
			// btnToggle21
			// 
			this->btnToggle21->Location = System::Drawing::Point(210, 169);
			this->btnToggle21->Name = L"btnToggle21";
			this->btnToggle21->Size = System::Drawing::Size(30, 23);
			this->btnToggle21->TabIndex = 141;
			this->btnToggle21->Tag = L"21";
			this->btnToggle21->Text = L"I";
			this->btnToggle21->UseVisualStyleBackColor = true;
			this->btnToggle21->Click += gcnew System::EventHandler(this, &Form1::btnToggle_Click);
			// 
			// btnToggle22
			// 
			this->btnToggle22->Location = System::Drawing::Point(179, 169);
			this->btnToggle22->Name = L"btnToggle22";
			this->btnToggle22->Size = System::Drawing::Size(30, 23);
			this->btnToggle22->TabIndex = 140;
			this->btnToggle22->Tag = L"22";
			this->btnToggle22->Text = L"I";
			this->btnToggle22->UseVisualStyleBackColor = true;
			this->btnToggle22->Click += gcnew System::EventHandler(this, &Form1::btnToggle_Click);
			// 
			// btnToggle23
			// 
			this->btnToggle23->Location = System::Drawing::Point(147, 169);
			this->btnToggle23->Name = L"btnToggle23";
			this->btnToggle23->Size = System::Drawing::Size(30, 23);
			this->btnToggle23->TabIndex = 139;
			this->btnToggle23->Tag = L"23";
			this->btnToggle23->Text = L"I";
			this->btnToggle23->UseVisualStyleBackColor = true;
			this->btnToggle23->Click += gcnew System::EventHandler(this, &Form1::btnToggle_Click);
			// 
			// btnToggle8
			// 
			this->btnToggle8->Location = System::Drawing::Point(784, 73);
			this->btnToggle8->Name = L"btnToggle8";
			this->btnToggle8->Size = System::Drawing::Size(30, 23);
			this->btnToggle8->TabIndex = 138;
			this->btnToggle8->Tag = L"8";
			this->btnToggle8->Text = L"I";
			this->btnToggle8->UseVisualStyleBackColor = true;
			this->btnToggle8->Click += gcnew System::EventHandler(this, &Form1::btnToggle_Click);
			// 
			// btnToggle9
			// 
			this->btnToggle9->Location = System::Drawing::Point(754, 73);
			this->btnToggle9->Name = L"btnToggle9";
			this->btnToggle9->Size = System::Drawing::Size(30, 23);
			this->btnToggle9->TabIndex = 137;
			this->btnToggle9->Tag = L"9";
			this->btnToggle9->Text = L"I";
			this->btnToggle9->UseVisualStyleBackColor = true;
			this->btnToggle9->Click += gcnew System::EventHandler(this, &Form1::btnToggle_Click);
			// 
			// btnToggle10
			// 
			this->btnToggle10->Location = System::Drawing::Point(723, 73);
			this->btnToggle10->Name = L"btnToggle10";
			this->btnToggle10->Size = System::Drawing::Size(30, 23);
			this->btnToggle10->TabIndex = 136;
			this->btnToggle10->Tag = L"10";
			this->btnToggle10->Text = L"I";
			this->btnToggle10->UseVisualStyleBackColor = true;
			this->btnToggle10->Click += gcnew System::EventHandler(this, &Form1::btnToggle_Click);
			// 
			// btnToggle11
			// 
			this->btnToggle11->Location = System::Drawing::Point(692, 73);
			this->btnToggle11->Name = L"btnToggle11";
			this->btnToggle11->Size = System::Drawing::Size(30, 23);
			this->btnToggle11->TabIndex = 135;
			this->btnToggle11->Tag = L"11";
			this->btnToggle11->Text = L"I";
			this->btnToggle11->UseVisualStyleBackColor = true;
			this->btnToggle11->Click += gcnew System::EventHandler(this, &Form1::btnToggle_Click);
			// 
			// btnToggle12
			// 
			this->btnToggle12->Location = System::Drawing::Point(661, 73);
			this->btnToggle12->Name = L"btnToggle12";
			this->btnToggle12->Size = System::Drawing::Size(30, 23);
			this->btnToggle12->TabIndex = 134;
			this->btnToggle12->Tag = L"12";
			this->btnToggle12->Text = L"I";
			this->btnToggle12->UseVisualStyleBackColor = true;
			this->btnToggle12->Click += gcnew System::EventHandler(this, &Form1::btnToggle_Click);
			// 
			// btnToggle13
			// 
			this->btnToggle13->Location = System::Drawing::Point(630, 73);
			this->btnToggle13->Name = L"btnToggle13";
			this->btnToggle13->Size = System::Drawing::Size(30, 23);
			this->btnToggle13->TabIndex = 133;
			this->btnToggle13->Tag = L"13";
			this->btnToggle13->Text = L"I";
			this->btnToggle13->UseVisualStyleBackColor = true;
			this->btnToggle13->Click += gcnew System::EventHandler(this, &Form1::btnToggle_Click);
			// 
			// btnToggle14
			// 
			this->btnToggle14->Location = System::Drawing::Point(599, 73);
			this->btnToggle14->Name = L"btnToggle14";
			this->btnToggle14->Size = System::Drawing::Size(30, 23);
			this->btnToggle14->TabIndex = 132;
			this->btnToggle14->Tag = L"14";
			this->btnToggle14->Text = L"I";
			this->btnToggle14->UseVisualStyleBackColor = true;
			this->btnToggle14->Click += gcnew System::EventHandler(this, &Form1::btnToggle_Click);
			// 
			// btnToggle0
			// 
			this->btnToggle0->Location = System::Drawing::Point(364, 75);
			this->btnToggle0->Name = L"btnToggle0";
			this->btnToggle0->Size = System::Drawing::Size(30, 23);
			this->btnToggle0->TabIndex = 131;
			this->btnToggle0->Tag = L"0";
			this->btnToggle0->Text = L"I";
			this->btnToggle0->UseVisualStyleBackColor = true;
			this->btnToggle0->Click += gcnew System::EventHandler(this, &Form1::btnToggle_Click);
			// 
			// btnToggle1
			// 
			this->btnToggle1->Location = System::Drawing::Point(333, 75);
			this->btnToggle1->Name = L"btnToggle1";
			this->btnToggle1->Size = System::Drawing::Size(30, 23);
			this->btnToggle1->TabIndex = 130;
			this->btnToggle1->Tag = L"1";
			this->btnToggle1->Text = L"I";
			this->btnToggle1->UseVisualStyleBackColor = true;
			this->btnToggle1->Click += gcnew System::EventHandler(this, &Form1::btnToggle_Click);
			// 
			// btnToggle2
			// 
			this->btnToggle2->Location = System::Drawing::Point(302, 75);
			this->btnToggle2->Name = L"btnToggle2";
			this->btnToggle2->Size = System::Drawing::Size(30, 23);
			this->btnToggle2->TabIndex = 129;
			this->btnToggle2->Tag = L"2";
			this->btnToggle2->Text = L"I";
			this->btnToggle2->UseVisualStyleBackColor = true;
			this->btnToggle2->Click += gcnew System::EventHandler(this, &Form1::btnToggle_Click);
			// 
			// btnToggle3
			// 
			this->btnToggle3->Location = System::Drawing::Point(271, 75);
			this->btnToggle3->Name = L"btnToggle3";
			this->btnToggle3->Size = System::Drawing::Size(30, 23);
			this->btnToggle3->TabIndex = 128;
			this->btnToggle3->Tag = L"3";
			this->btnToggle3->Text = L"I";
			this->btnToggle3->UseVisualStyleBackColor = true;
			this->btnToggle3->Click += gcnew System::EventHandler(this, &Form1::btnToggle_Click);
			// 
			// btnToggle4
			// 
			this->btnToggle4->Location = System::Drawing::Point(241, 75);
			this->btnToggle4->Name = L"btnToggle4";
			this->btnToggle4->Size = System::Drawing::Size(30, 23);
			this->btnToggle4->TabIndex = 127;
			this->btnToggle4->Tag = L"4";
			this->btnToggle4->Text = L"I";
			this->btnToggle4->UseVisualStyleBackColor = true;
			this->btnToggle4->Click += gcnew System::EventHandler(this, &Form1::btnToggle_Click);
			// 
			// btnToggle5
			// 
			this->btnToggle5->Location = System::Drawing::Point(210, 75);
			this->btnToggle5->Name = L"btnToggle5";
			this->btnToggle5->Size = System::Drawing::Size(30, 23);
			this->btnToggle5->TabIndex = 126;
			this->btnToggle5->Tag = L"5";
			this->btnToggle5->Text = L"I";
			this->btnToggle5->UseVisualStyleBackColor = true;
			this->btnToggle5->Click += gcnew System::EventHandler(this, &Form1::btnToggle_Click);
			// 
			// btnToggle6
			// 
			this->btnToggle6->Location = System::Drawing::Point(179, 75);
			this->btnToggle6->Name = L"btnToggle6";
			this->btnToggle6->Size = System::Drawing::Size(30, 23);
			this->btnToggle6->TabIndex = 125;
			this->btnToggle6->Tag = L"6";
			this->btnToggle6->Text = L"I";
			this->btnToggle6->UseVisualStyleBackColor = true;
			this->btnToggle6->Click += gcnew System::EventHandler(this, &Form1::btnToggle_Click);
			// 
			// label12
			// 
			this->label12->AutoSize = true;
			this->label12->Location = System::Drawing::Point(427, 174);
			this->label12->Name = L"label12";
			this->label12->Size = System::Drawing::Size(134, 13);
			this->label12->TabIndex = 124;
			this->label12->Text = L"Toggle Inpu/Output Mode:";
			// 
			// label7
			// 
			this->label7->AutoSize = true;
			this->label7->Location = System::Drawing::Point(6, 172);
			this->label7->Name = L"label7";
			this->label7->Size = System::Drawing::Size(134, 13);
			this->label7->TabIndex = 123;
			this->label7->Text = L"Toggle Inpu/Output Mode:";
			// 
			// label3
			// 
			this->label3->AutoSize = true;
			this->label3->Location = System::Drawing::Point(428, 77);
			this->label3->Name = L"label3";
			this->label3->Size = System::Drawing::Size(134, 13);
			this->label3->TabIndex = 122;
			this->label3->Text = L"Toggle Inpu/Output Mode:";
			// 
			// label1
			// 
			this->label1->AutoSize = true;
			this->label1->Location = System::Drawing::Point(8, 80);
			this->label1->Name = L"label1";
			this->label1->Size = System::Drawing::Size(134, 13);
			this->label1->TabIndex = 121;
			this->label1->Text = L"Toggle Inpu/Output Mode:";
			// 
			// label11
			// 
			this->label11->AutoSize = true;
			this->label11->Location = System::Drawing::Point(494, 140);
			this->label11->Name = L"label11";
			this->label11->Size = System::Drawing::Size(69, 13);
			this->label11->TabIndex = 120;
			this->label11->Text = L"In/Out State:";
			this->label11->TextAlign = System::Drawing::ContentAlignment::MiddleRight;
			// 
			// label10
			// 
			this->label10->AutoSize = true;
			this->label10->Location = System::Drawing::Point(495, 47);
			this->label10->Name = L"label10";
			this->label10->Size = System::Drawing::Size(69, 13);
			this->label10->TabIndex = 119;
			this->label10->Text = L"In/Out State:";
			this->label10->TextAlign = System::Drawing::ContentAlignment::MiddleRight;
			// 
			// label9
			// 
			this->label9->AutoSize = true;
			this->label9->Location = System::Drawing::Point(70, 139);
			this->label9->Name = L"label9";
			this->label9->Size = System::Drawing::Size(69, 13);
			this->label9->TabIndex = 118;
			this->label9->Text = L"In/Out State:";
			this->label9->TextAlign = System::Drawing::ContentAlignment::MiddleRight;
			// 
			// label2
			// 
			this->label2->AutoSize = true;
			this->label2->Location = System::Drawing::Point(71, 49);
			this->label2->Name = L"label2";
			this->label2->Size = System::Drawing::Size(69, 13);
			this->label2->TabIndex = 3;
			this->label2->Text = L"In/Out State:";
			this->label2->TextAlign = System::Drawing::ContentAlignment::MiddleRight;
			// 
			// checkBoxC0_21
			// 
			this->checkBoxC0_21->Appearance = System::Windows::Forms::Appearance::Button;
			this->checkBoxC0_21->BackColor = System::Drawing::Color::Gray;
			this->checkBoxC0_21->FlatAppearance->CheckedBackColor = System::Drawing::Color::Lime;
			this->checkBoxC0_21->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->checkBoxC0_21->Location = System::Drawing::Point(241, 133);
			this->checkBoxC0_21->Name = L"checkBoxC0_21";
			this->checkBoxC0_21->Size = System::Drawing::Size(29, 23);
			this->checkBoxC0_21->TabIndex = 113;
			this->checkBoxC0_21->Tag = L"20";
			this->checkBoxC0_21->Text = L"4";
			this->checkBoxC0_21->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->checkBoxC0_21->UseVisualStyleBackColor = false;
			this->checkBoxC0_21->Click += gcnew System::EventHandler(this, &Form1::checkBoxPin_CheckedChanged);
			// 
			// label15
			// 
			this->label15->AutoSize = true;
			this->label15->Location = System::Drawing::Point(252, 111);
			this->label15->Name = L"label15";
			this->label15->Size = System::Drawing::Size(36, 13);
			this->label15->TabIndex = 108;
			this->label15->Text = L"Port C";
			// 
			// checkBoxC0_23
			// 
			this->checkBoxC0_23->Appearance = System::Windows::Forms::Appearance::Button;
			this->checkBoxC0_23->BackColor = System::Drawing::Color::Gray;
			this->checkBoxC0_23->FlatAppearance->CheckedBackColor = System::Drawing::Color::Lime;
			this->checkBoxC0_23->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->checkBoxC0_23->Location = System::Drawing::Point(179, 133);
			this->checkBoxC0_23->Name = L"checkBoxC0_23";
			this->checkBoxC0_23->Size = System::Drawing::Size(29, 23);
			this->checkBoxC0_23->TabIndex = 111;
			this->checkBoxC0_23->Tag = L"22";
			this->checkBoxC0_23->Text = L"6";
			this->checkBoxC0_23->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->checkBoxC0_23->UseVisualStyleBackColor = false;
			this->checkBoxC0_23->Click += gcnew System::EventHandler(this, &Form1::checkBoxPin_CheckedChanged);
			// 
			// btnToggle15
			// 
			this->btnToggle15->Location = System::Drawing::Point(567, 73);
			this->btnToggle15->Name = L"btnToggle15";
			this->btnToggle15->Size = System::Drawing::Size(30, 23);
			this->btnToggle15->TabIndex = 99;
			this->btnToggle15->Tag = L"15";
			this->btnToggle15->Text = L"I";
			this->btnToggle15->UseVisualStyleBackColor = true;
			this->btnToggle15->Click += gcnew System::EventHandler(this, &Form1::btnToggle_Click);
			// 
			// checkBoxC0_20
			// 
			this->checkBoxC0_20->Appearance = System::Windows::Forms::Appearance::Button;
			this->checkBoxC0_20->BackColor = System::Drawing::Color::Gray;
			this->checkBoxC0_20->FlatAppearance->CheckedBackColor = System::Drawing::Color::Lime;
			this->checkBoxC0_20->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->checkBoxC0_20->Location = System::Drawing::Point(272, 133);
			this->checkBoxC0_20->Name = L"checkBoxC0_20";
			this->checkBoxC0_20->Size = System::Drawing::Size(29, 23);
			this->checkBoxC0_20->TabIndex = 114;
			this->checkBoxC0_20->Tag = L"19";
			this->checkBoxC0_20->Text = L"3";
			this->checkBoxC0_20->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->checkBoxC0_20->UseVisualStyleBackColor = false;
			this->checkBoxC0_20->Click += gcnew System::EventHandler(this, &Form1::checkBoxPin_CheckedChanged);
			// 
			// label14
			// 
			this->label14->AutoSize = true;
			this->label14->Location = System::Drawing::Point(673, 18);
			this->label14->Name = L"label14";
			this->label14->Size = System::Drawing::Size(36, 13);
			this->label14->TabIndex = 98;
			this->label14->Text = L"Port B";
			// 
			// checkBoxC0_24
			// 
			this->checkBoxC0_24->Appearance = System::Windows::Forms::Appearance::Button;
			this->checkBoxC0_24->BackColor = System::Drawing::Color::Gray;
			this->checkBoxC0_24->FlatAppearance->CheckedBackColor = System::Drawing::Color::Lime;
			this->checkBoxC0_24->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->checkBoxC0_24->Location = System::Drawing::Point(148, 133);
			this->checkBoxC0_24->Name = L"checkBoxC0_24";
			this->checkBoxC0_24->Size = System::Drawing::Size(29, 23);
			this->checkBoxC0_24->TabIndex = 110;
			this->checkBoxC0_24->Tag = L"23";
			this->checkBoxC0_24->Text = L"7";
			this->checkBoxC0_24->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->checkBoxC0_24->UseVisualStyleBackColor = false;
			this->checkBoxC0_24->Click += gcnew System::EventHandler(this, &Form1::checkBoxPin_CheckedChanged);
			// 
			// checkBoxC0_22
			// 
			this->checkBoxC0_22->Appearance = System::Windows::Forms::Appearance::Button;
			this->checkBoxC0_22->BackColor = System::Drawing::Color::Gray;
			this->checkBoxC0_22->FlatAppearance->CheckedBackColor = System::Drawing::Color::Lime;
			this->checkBoxC0_22->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->checkBoxC0_22->Location = System::Drawing::Point(210, 133);
			this->checkBoxC0_22->Name = L"checkBoxC0_22";
			this->checkBoxC0_22->Size = System::Drawing::Size(29, 23);
			this->checkBoxC0_22->TabIndex = 112;
			this->checkBoxC0_22->Tag = L"21";
			this->checkBoxC0_22->Text = L"5";
			this->checkBoxC0_22->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->checkBoxC0_22->UseVisualStyleBackColor = false;
			this->checkBoxC0_22->Click += gcnew System::EventHandler(this, &Form1::checkBoxPin_CheckedChanged);
			// 
			// btnToggle7
			// 
			this->btnToggle7->Location = System::Drawing::Point(147, 75);
			this->btnToggle7->Name = L"btnToggle7";
			this->btnToggle7->Size = System::Drawing::Size(30, 23);
			this->btnToggle7->TabIndex = 89;
			this->btnToggle7->Tag = L"7";
			this->btnToggle7->Text = L"I";
			this->btnToggle7->UseVisualStyleBackColor = true;
			this->btnToggle7->Click += gcnew System::EventHandler(this, &Form1::btnToggle_Click);
			// 
			// label4
			// 
			this->label4->AutoSize = true;
			this->label4->Location = System::Drawing::Point(667, 111);
			this->label4->Name = L"label4";
			this->label4->Size = System::Drawing::Size(37, 13);
			this->label4->TabIndex = 65;
			this->label4->Text = L"Port D";
			// 
			// checkBoxC0_17
			// 
			this->checkBoxC0_17->Appearance = System::Windows::Forms::Appearance::Button;
			this->checkBoxC0_17->BackColor = System::Drawing::Color::Gray;
			this->checkBoxC0_17->FlatAppearance->CheckedBackColor = System::Drawing::Color::Lime;
			this->checkBoxC0_17->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->checkBoxC0_17->ForeColor = System::Drawing::SystemColors::ControlText;
			this->checkBoxC0_17->Location = System::Drawing::Point(365, 133);
			this->checkBoxC0_17->Name = L"checkBoxC0_17";
			this->checkBoxC0_17->Size = System::Drawing::Size(29, 23);
			this->checkBoxC0_17->TabIndex = 117;
			this->checkBoxC0_17->Tag = L"16";
			this->checkBoxC0_17->Text = L"0";
			this->checkBoxC0_17->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->checkBoxC0_17->UseVisualStyleBackColor = false;
			this->checkBoxC0_17->Click += gcnew System::EventHandler(this, &Form1::checkBoxPin_CheckedChanged);
			// 
			// label13
			// 
			this->label13->AutoSize = true;
			this->label13->Location = System::Drawing::Point(253, 22);
			this->label13->Name = L"label13";
			this->label13->Size = System::Drawing::Size(36, 13);
			this->label13->TabIndex = 88;
			this->label13->Text = L"Port A";
			// 
			// checkBoxA1_25
			// 
			this->checkBoxA1_25->Appearance = System::Windows::Forms::Appearance::Button;
			this->checkBoxA1_25->BackColor = System::Drawing::Color::Gray;
			this->checkBoxA1_25->FlatAppearance->CheckedBackColor = System::Drawing::Color::Lime;
			this->checkBoxA1_25->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->checkBoxA1_25->Location = System::Drawing::Point(785, 133);
			this->checkBoxA1_25->Name = L"checkBoxA1_25";
			this->checkBoxA1_25->Size = System::Drawing::Size(30, 23);
			this->checkBoxA1_25->TabIndex = 67;
			this->checkBoxA1_25->Tag = L"24";
			this->checkBoxA1_25->Text = L"0";
			this->checkBoxA1_25->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->checkBoxA1_25->UseVisualStyleBackColor = false;
			this->checkBoxA1_25->Click += gcnew System::EventHandler(this, &Form1::checkBoxPin_CheckedChanged);
			// 
			// checkBoxA0_8
			// 
			this->checkBoxA0_8->Appearance = System::Windows::Forms::Appearance::Button;
			this->checkBoxA0_8->BackColor = System::Drawing::Color::Gray;
			this->checkBoxA0_8->FlatAppearance->CheckedBackColor = System::Drawing::Color::Lime;
			this->checkBoxA0_8->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->checkBoxA0_8->Location = System::Drawing::Point(148, 42);
			this->checkBoxA0_8->Name = L"checkBoxA0_8";
			this->checkBoxA0_8->Size = System::Drawing::Size(29, 23);
			this->checkBoxA0_8->TabIndex = 90;
			this->checkBoxA0_8->Tag = L"7";
			this->checkBoxA0_8->Text = L"7";
			this->checkBoxA0_8->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->checkBoxA0_8->UseVisualStyleBackColor = false;
			this->checkBoxA0_8->Click += gcnew System::EventHandler(this, &Form1::checkBoxPin_CheckedChanged);
			// 
			// checkBoxA1_29
			// 
			this->checkBoxA1_29->Appearance = System::Windows::Forms::Appearance::Button;
			this->checkBoxA1_29->BackColor = System::Drawing::Color::Gray;
			this->checkBoxA1_29->FlatAppearance->CheckedBackColor = System::Drawing::Color::Lime;
			this->checkBoxA1_29->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->checkBoxA1_29->Location = System::Drawing::Point(661, 133);
			this->checkBoxA1_29->Name = L"checkBoxA1_29";
			this->checkBoxA1_29->Size = System::Drawing::Size(30, 23);
			this->checkBoxA1_29->TabIndex = 71;
			this->checkBoxA1_29->Tag = L"28";
			this->checkBoxA1_29->Text = L"4";
			this->checkBoxA1_29->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->checkBoxA1_29->UseVisualStyleBackColor = false;
			this->checkBoxA1_29->Click += gcnew System::EventHandler(this, &Form1::checkBoxPin_CheckedChanged);
			// 
			// checkBoxC0_18
			// 
			this->checkBoxC0_18->Appearance = System::Windows::Forms::Appearance::Button;
			this->checkBoxC0_18->BackColor = System::Drawing::Color::Gray;
			this->checkBoxC0_18->FlatAppearance->CheckedBackColor = System::Drawing::Color::Lime;
			this->checkBoxC0_18->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->checkBoxC0_18->Location = System::Drawing::Point(334, 133);
			this->checkBoxC0_18->Name = L"checkBoxC0_18";
			this->checkBoxC0_18->Size = System::Drawing::Size(29, 23);
			this->checkBoxC0_18->TabIndex = 116;
			this->checkBoxC0_18->Tag = L"17";
			this->checkBoxC0_18->Text = L"1";
			this->checkBoxC0_18->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->checkBoxC0_18->UseVisualStyleBackColor = false;
			this->checkBoxC0_18->Click += gcnew System::EventHandler(this, &Form1::checkBoxPin_CheckedChanged);
			// 
			// checkBoxA1_32
			// 
			this->checkBoxA1_32->Appearance = System::Windows::Forms::Appearance::Button;
			this->checkBoxA1_32->BackColor = System::Drawing::Color::Gray;
			this->checkBoxA1_32->FlatAppearance->CheckedBackColor = System::Drawing::Color::Lime;
			this->checkBoxA1_32->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->checkBoxA1_32->ForeColor = System::Drawing::SystemColors::ControlText;
			this->checkBoxA1_32->Location = System::Drawing::Point(568, 133);
			this->checkBoxA1_32->Name = L"checkBoxA1_32";
			this->checkBoxA1_32->Size = System::Drawing::Size(30, 23);
			this->checkBoxA1_32->TabIndex = 74;
			this->checkBoxA1_32->Tag = L"31";
			this->checkBoxA1_32->Text = L"7";
			this->checkBoxA1_32->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->checkBoxA1_32->UseVisualStyleBackColor = false;
			this->checkBoxA1_32->Click += gcnew System::EventHandler(this, &Form1::checkBoxPin_CheckedChanged);
			// 
			// checkBoxA1_28
			// 
			this->checkBoxA1_28->Appearance = System::Windows::Forms::Appearance::Button;
			this->checkBoxA1_28->BackColor = System::Drawing::Color::Gray;
			this->checkBoxA1_28->FlatAppearance->CheckedBackColor = System::Drawing::Color::Lime;
			this->checkBoxA1_28->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->checkBoxA1_28->Location = System::Drawing::Point(692, 133);
			this->checkBoxA1_28->Name = L"checkBoxA1_28";
			this->checkBoxA1_28->Size = System::Drawing::Size(30, 23);
			this->checkBoxA1_28->TabIndex = 70;
			this->checkBoxA1_28->Tag = L"27";
			this->checkBoxA1_28->Text = L"3";
			this->checkBoxA1_28->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->checkBoxA1_28->UseVisualStyleBackColor = false;
			this->checkBoxA1_28->Click += gcnew System::EventHandler(this, &Form1::checkBoxPin_CheckedChanged);
			// 
			// checkBoxA0_3
			// 
			this->checkBoxA0_3->Appearance = System::Windows::Forms::Appearance::Button;
			this->checkBoxA0_3->BackColor = System::Drawing::Color::Gray;
			this->checkBoxA0_3->FlatAppearance->CheckedBackColor = System::Drawing::Color::Lime;
			this->checkBoxA0_3->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->checkBoxA0_3->Location = System::Drawing::Point(303, 42);
			this->checkBoxA0_3->Name = L"checkBoxA0_3";
			this->checkBoxA0_3->Size = System::Drawing::Size(29, 23);
			this->checkBoxA0_3->TabIndex = 95;
			this->checkBoxA0_3->Tag = L"2";
			this->checkBoxA0_3->Text = L"2";
			this->checkBoxA0_3->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->checkBoxA0_3->UseVisualStyleBackColor = false;
			this->checkBoxA0_3->Click += gcnew System::EventHandler(this, &Form1::checkBoxPin_CheckedChanged);
			// 
			// checkBoxA1_26
			// 
			this->checkBoxA1_26->Appearance = System::Windows::Forms::Appearance::Button;
			this->checkBoxA1_26->BackColor = System::Drawing::Color::Gray;
			this->checkBoxA1_26->FlatAppearance->CheckedBackColor = System::Drawing::Color::Lime;
			this->checkBoxA1_26->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->checkBoxA1_26->Location = System::Drawing::Point(754, 133);
			this->checkBoxA1_26->Name = L"checkBoxA1_26";
			this->checkBoxA1_26->Size = System::Drawing::Size(30, 23);
			this->checkBoxA1_26->TabIndex = 68;
			this->checkBoxA1_26->Tag = L"25";
			this->checkBoxA1_26->Text = L"1";
			this->checkBoxA1_26->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->checkBoxA1_26->UseVisualStyleBackColor = false;
			this->checkBoxA1_26->Click += gcnew System::EventHandler(this, &Form1::checkBoxPin_CheckedChanged);
			// 
			// checkBoxA0_4
			// 
			this->checkBoxA0_4->Appearance = System::Windows::Forms::Appearance::Button;
			this->checkBoxA0_4->BackColor = System::Drawing::Color::Gray;
			this->checkBoxA0_4->FlatAppearance->CheckedBackColor = System::Drawing::Color::Lime;
			this->checkBoxA0_4->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->checkBoxA0_4->Location = System::Drawing::Point(272, 42);
			this->checkBoxA0_4->Name = L"checkBoxA0_4";
			this->checkBoxA0_4->Size = System::Drawing::Size(29, 23);
			this->checkBoxA0_4->TabIndex = 94;
			this->checkBoxA0_4->Tag = L"3";
			this->checkBoxA0_4->Text = L"3";
			this->checkBoxA0_4->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->checkBoxA0_4->UseVisualStyleBackColor = false;
			this->checkBoxA0_4->Click += gcnew System::EventHandler(this, &Form1::checkBoxPin_CheckedChanged);
			// 
			// checkBoxA1_27
			// 
			this->checkBoxA1_27->Appearance = System::Windows::Forms::Appearance::Button;
			this->checkBoxA1_27->BackColor = System::Drawing::Color::Gray;
			this->checkBoxA1_27->FlatAppearance->CheckedBackColor = System::Drawing::Color::Lime;
			this->checkBoxA1_27->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->checkBoxA1_27->Location = System::Drawing::Point(723, 133);
			this->checkBoxA1_27->Name = L"checkBoxA1_27";
			this->checkBoxA1_27->Size = System::Drawing::Size(30, 23);
			this->checkBoxA1_27->TabIndex = 69;
			this->checkBoxA1_27->Tag = L"26";
			this->checkBoxA1_27->Text = L"2";
			this->checkBoxA1_27->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->checkBoxA1_27->UseVisualStyleBackColor = false;
			this->checkBoxA1_27->Click += gcnew System::EventHandler(this, &Form1::checkBoxPin_CheckedChanged);
			// 
			// checkBoxC0_19
			// 
			this->checkBoxC0_19->Appearance = System::Windows::Forms::Appearance::Button;
			this->checkBoxC0_19->BackColor = System::Drawing::Color::Gray;
			this->checkBoxC0_19->FlatAppearance->CheckedBackColor = System::Drawing::Color::Lime;
			this->checkBoxC0_19->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->checkBoxC0_19->Location = System::Drawing::Point(303, 133);
			this->checkBoxC0_19->Name = L"checkBoxC0_19";
			this->checkBoxC0_19->Size = System::Drawing::Size(29, 23);
			this->checkBoxC0_19->TabIndex = 115;
			this->checkBoxC0_19->Tag = L"18";
			this->checkBoxC0_19->Text = L"2";
			this->checkBoxC0_19->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->checkBoxC0_19->UseVisualStyleBackColor = false;
			this->checkBoxC0_19->Click += gcnew System::EventHandler(this, &Form1::checkBoxPin_CheckedChanged);
			// 
			// checkBoxA0_2
			// 
			this->checkBoxA0_2->Appearance = System::Windows::Forms::Appearance::Button;
			this->checkBoxA0_2->BackColor = System::Drawing::Color::Gray;
			this->checkBoxA0_2->FlatAppearance->CheckedBackColor = System::Drawing::Color::Lime;
			this->checkBoxA0_2->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->checkBoxA0_2->Location = System::Drawing::Point(334, 42);
			this->checkBoxA0_2->Name = L"checkBoxA0_2";
			this->checkBoxA0_2->Size = System::Drawing::Size(29, 23);
			this->checkBoxA0_2->TabIndex = 96;
			this->checkBoxA0_2->Tag = L"1";
			this->checkBoxA0_2->Text = L"1";
			this->checkBoxA0_2->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->checkBoxA0_2->UseVisualStyleBackColor = false;
			this->checkBoxA0_2->Click += gcnew System::EventHandler(this, &Form1::checkBoxPin_CheckedChanged);
			// 
			// checkBoxA1_31
			// 
			this->checkBoxA1_31->Appearance = System::Windows::Forms::Appearance::Button;
			this->checkBoxA1_31->BackColor = System::Drawing::Color::Gray;
			this->checkBoxA1_31->FlatAppearance->CheckedBackColor = System::Drawing::Color::Lime;
			this->checkBoxA1_31->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->checkBoxA1_31->Location = System::Drawing::Point(599, 133);
			this->checkBoxA1_31->Name = L"checkBoxA1_31";
			this->checkBoxA1_31->Size = System::Drawing::Size(30, 23);
			this->checkBoxA1_31->TabIndex = 73;
			this->checkBoxA1_31->Tag = L"30";
			this->checkBoxA1_31->Text = L"6";
			this->checkBoxA1_31->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->checkBoxA1_31->UseVisualStyleBackColor = false;
			this->checkBoxA1_31->Click += gcnew System::EventHandler(this, &Form1::checkBoxPin_CheckedChanged);
			// 
			// checkBoxA0_5
			// 
			this->checkBoxA0_5->Appearance = System::Windows::Forms::Appearance::Button;
			this->checkBoxA0_5->BackColor = System::Drawing::Color::Gray;
			this->checkBoxA0_5->FlatAppearance->CheckedBackColor = System::Drawing::Color::Lime;
			this->checkBoxA0_5->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->checkBoxA0_5->Location = System::Drawing::Point(241, 42);
			this->checkBoxA0_5->Name = L"checkBoxA0_5";
			this->checkBoxA0_5->Size = System::Drawing::Size(29, 23);
			this->checkBoxA0_5->TabIndex = 93;
			this->checkBoxA0_5->Tag = L"4";
			this->checkBoxA0_5->Text = L"4";
			this->checkBoxA0_5->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->checkBoxA0_5->UseVisualStyleBackColor = false;
			this->checkBoxA0_5->Click += gcnew System::EventHandler(this, &Form1::checkBoxPin_CheckedChanged);
			// 
			// checkBoxA1_30
			// 
			this->checkBoxA1_30->Appearance = System::Windows::Forms::Appearance::Button;
			this->checkBoxA1_30->BackColor = System::Drawing::Color::Gray;
			this->checkBoxA1_30->FlatAppearance->CheckedBackColor = System::Drawing::Color::Lime;
			this->checkBoxA1_30->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->checkBoxA1_30->Location = System::Drawing::Point(630, 133);
			this->checkBoxA1_30->Name = L"checkBoxA1_30";
			this->checkBoxA1_30->Size = System::Drawing::Size(30, 23);
			this->checkBoxA1_30->TabIndex = 72;
			this->checkBoxA1_30->Tag = L"29";
			this->checkBoxA1_30->Text = L"5";
			this->checkBoxA1_30->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->checkBoxA1_30->UseVisualStyleBackColor = false;
			this->checkBoxA1_30->Click += gcnew System::EventHandler(this, &Form1::checkBoxPin_CheckedChanged);
			// 
			// checkBoxA0_1
			// 
			this->checkBoxA0_1->Appearance = System::Windows::Forms::Appearance::Button;
			this->checkBoxA0_1->BackColor = System::Drawing::Color::Gray;
			this->checkBoxA0_1->FlatAppearance->CheckedBackColor = System::Drawing::Color::Lime;
			this->checkBoxA0_1->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->checkBoxA0_1->ForeColor = System::Drawing::SystemColors::ControlText;
			this->checkBoxA0_1->Location = System::Drawing::Point(365, 42);
			this->checkBoxA0_1->Name = L"checkBoxA0_1";
			this->checkBoxA0_1->Size = System::Drawing::Size(29, 23);
			this->checkBoxA0_1->TabIndex = 97;
			this->checkBoxA0_1->Tag = L"0";
			this->checkBoxA0_1->Text = L"0";
			this->checkBoxA0_1->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->checkBoxA0_1->UseVisualStyleBackColor = false;
			this->checkBoxA0_1->Click += gcnew System::EventHandler(this, &Form1::checkBoxPin_CheckedChanged);
			// 
			// checkBoxA0_6
			// 
			this->checkBoxA0_6->Appearance = System::Windows::Forms::Appearance::Button;
			this->checkBoxA0_6->BackColor = System::Drawing::Color::Gray;
			this->checkBoxA0_6->FlatAppearance->CheckedBackColor = System::Drawing::Color::Lime;
			this->checkBoxA0_6->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->checkBoxA0_6->Location = System::Drawing::Point(210, 42);
			this->checkBoxA0_6->Name = L"checkBoxA0_6";
			this->checkBoxA0_6->Size = System::Drawing::Size(29, 23);
			this->checkBoxA0_6->TabIndex = 92;
			this->checkBoxA0_6->Tag = L"5";
			this->checkBoxA0_6->Text = L"5";
			this->checkBoxA0_6->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->checkBoxA0_6->UseVisualStyleBackColor = false;
			this->checkBoxA0_6->Click += gcnew System::EventHandler(this, &Form1::checkBoxPin_CheckedChanged);
			// 
			// checkBoxA0_7
			// 
			this->checkBoxA0_7->Appearance = System::Windows::Forms::Appearance::Button;
			this->checkBoxA0_7->BackColor = System::Drawing::Color::Gray;
			this->checkBoxA0_7->FlatAppearance->CheckedBackColor = System::Drawing::Color::Lime;
			this->checkBoxA0_7->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->checkBoxA0_7->Location = System::Drawing::Point(179, 42);
			this->checkBoxA0_7->Name = L"checkBoxA0_7";
			this->checkBoxA0_7->Size = System::Drawing::Size(29, 23);
			this->checkBoxA0_7->TabIndex = 91;
			this->checkBoxA0_7->Tag = L"6";
			this->checkBoxA0_7->Text = L"6";
			this->checkBoxA0_7->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->checkBoxA0_7->UseVisualStyleBackColor = false;
			this->checkBoxA0_7->Click += gcnew System::EventHandler(this, &Form1::checkBoxPin_CheckedChanged);
			// 
			// checkBoxB0_16
			// 
			this->checkBoxB0_16->Appearance = System::Windows::Forms::Appearance::Button;
			this->checkBoxB0_16->BackColor = System::Drawing::Color::Gray;
			this->checkBoxB0_16->FlatAppearance->CheckedBackColor = System::Drawing::Color::Lime;
			this->checkBoxB0_16->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->checkBoxB0_16->Location = System::Drawing::Point(568, 42);
			this->checkBoxB0_16->Name = L"checkBoxB0_16";
			this->checkBoxB0_16->Size = System::Drawing::Size(29, 23);
			this->checkBoxB0_16->TabIndex = 100;
			this->checkBoxB0_16->Tag = L"15";
			this->checkBoxB0_16->Text = L"7";
			this->checkBoxB0_16->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->checkBoxB0_16->UseVisualStyleBackColor = false;
			this->checkBoxB0_16->Click += gcnew System::EventHandler(this, &Form1::checkBoxPin_CheckedChanged);
			// 
			// checkBoxB0_14
			// 
			this->checkBoxB0_14->Appearance = System::Windows::Forms::Appearance::Button;
			this->checkBoxB0_14->BackColor = System::Drawing::Color::Gray;
			this->checkBoxB0_14->FlatAppearance->CheckedBackColor = System::Drawing::Color::Lime;
			this->checkBoxB0_14->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->checkBoxB0_14->Location = System::Drawing::Point(630, 42);
			this->checkBoxB0_14->Name = L"checkBoxB0_14";
			this->checkBoxB0_14->Size = System::Drawing::Size(29, 23);
			this->checkBoxB0_14->TabIndex = 102;
			this->checkBoxB0_14->Tag = L"13";
			this->checkBoxB0_14->Text = L"5";
			this->checkBoxB0_14->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->checkBoxB0_14->UseVisualStyleBackColor = false;
			this->checkBoxB0_14->Click += gcnew System::EventHandler(this, &Form1::checkBoxPin_CheckedChanged);
			// 
			// checkBoxB0_15
			// 
			this->checkBoxB0_15->Appearance = System::Windows::Forms::Appearance::Button;
			this->checkBoxB0_15->BackColor = System::Drawing::Color::Gray;
			this->checkBoxB0_15->FlatAppearance->CheckedBackColor = System::Drawing::Color::Lime;
			this->checkBoxB0_15->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->checkBoxB0_15->Location = System::Drawing::Point(599, 42);
			this->checkBoxB0_15->Name = L"checkBoxB0_15";
			this->checkBoxB0_15->Size = System::Drawing::Size(29, 23);
			this->checkBoxB0_15->TabIndex = 101;
			this->checkBoxB0_15->Tag = L"14";
			this->checkBoxB0_15->Text = L"6";
			this->checkBoxB0_15->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->checkBoxB0_15->UseVisualStyleBackColor = false;
			this->checkBoxB0_15->Click += gcnew System::EventHandler(this, &Form1::checkBoxPin_CheckedChanged);
			// 
			// checkBoxB0_11
			// 
			this->checkBoxB0_11->Appearance = System::Windows::Forms::Appearance::Button;
			this->checkBoxB0_11->BackColor = System::Drawing::Color::Gray;
			this->checkBoxB0_11->FlatAppearance->CheckedBackColor = System::Drawing::Color::Lime;
			this->checkBoxB0_11->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->checkBoxB0_11->Location = System::Drawing::Point(723, 42);
			this->checkBoxB0_11->Name = L"checkBoxB0_11";
			this->checkBoxB0_11->Size = System::Drawing::Size(29, 23);
			this->checkBoxB0_11->TabIndex = 105;
			this->checkBoxB0_11->Tag = L"10";
			this->checkBoxB0_11->Text = L"2";
			this->checkBoxB0_11->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->checkBoxB0_11->UseVisualStyleBackColor = false;
			this->checkBoxB0_11->Click += gcnew System::EventHandler(this, &Form1::checkBoxPin_CheckedChanged);
			// 
			// checkBoxB0_13
			// 
			this->checkBoxB0_13->Appearance = System::Windows::Forms::Appearance::Button;
			this->checkBoxB0_13->BackColor = System::Drawing::Color::Gray;
			this->checkBoxB0_13->FlatAppearance->CheckedBackColor = System::Drawing::Color::Lime;
			this->checkBoxB0_13->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->checkBoxB0_13->Location = System::Drawing::Point(661, 42);
			this->checkBoxB0_13->Name = L"checkBoxB0_13";
			this->checkBoxB0_13->Size = System::Drawing::Size(29, 23);
			this->checkBoxB0_13->TabIndex = 103;
			this->checkBoxB0_13->Tag = L"12";
			this->checkBoxB0_13->Text = L"4";
			this->checkBoxB0_13->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->checkBoxB0_13->UseVisualStyleBackColor = false;
			this->checkBoxB0_13->Click += gcnew System::EventHandler(this, &Form1::checkBoxPin_CheckedChanged);
			// 
			// checkBoxB0_10
			// 
			this->checkBoxB0_10->Appearance = System::Windows::Forms::Appearance::Button;
			this->checkBoxB0_10->BackColor = System::Drawing::Color::Gray;
			this->checkBoxB0_10->FlatAppearance->CheckedBackColor = System::Drawing::Color::Lime;
			this->checkBoxB0_10->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->checkBoxB0_10->Location = System::Drawing::Point(754, 42);
			this->checkBoxB0_10->Name = L"checkBoxB0_10";
			this->checkBoxB0_10->Size = System::Drawing::Size(29, 23);
			this->checkBoxB0_10->TabIndex = 106;
			this->checkBoxB0_10->Tag = L"9";
			this->checkBoxB0_10->Text = L"1";
			this->checkBoxB0_10->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->checkBoxB0_10->UseVisualStyleBackColor = false;
			this->checkBoxB0_10->Click += gcnew System::EventHandler(this, &Form1::checkBoxPin_CheckedChanged);
			// 
			// checkBoxB0_12
			// 
			this->checkBoxB0_12->Appearance = System::Windows::Forms::Appearance::Button;
			this->checkBoxB0_12->BackColor = System::Drawing::Color::Gray;
			this->checkBoxB0_12->FlatAppearance->CheckedBackColor = System::Drawing::Color::Lime;
			this->checkBoxB0_12->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->checkBoxB0_12->Location = System::Drawing::Point(692, 42);
			this->checkBoxB0_12->Name = L"checkBoxB0_12";
			this->checkBoxB0_12->Size = System::Drawing::Size(29, 23);
			this->checkBoxB0_12->TabIndex = 104;
			this->checkBoxB0_12->Tag = L"11";
			this->checkBoxB0_12->Text = L"3";
			this->checkBoxB0_12->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->checkBoxB0_12->UseVisualStyleBackColor = false;
			this->checkBoxB0_12->Click += gcnew System::EventHandler(this, &Form1::checkBoxPin_CheckedChanged);
			// 
			// checkBoxB0_9
			// 
			this->checkBoxB0_9->Appearance = System::Windows::Forms::Appearance::Button;
			this->checkBoxB0_9->BackColor = System::Drawing::Color::Gray;
			this->checkBoxB0_9->FlatAppearance->CheckedBackColor = System::Drawing::Color::Lime;
			this->checkBoxB0_9->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->checkBoxB0_9->ForeColor = System::Drawing::SystemColors::ControlText;
			this->checkBoxB0_9->Location = System::Drawing::Point(785, 42);
			this->checkBoxB0_9->Name = L"checkBoxB0_9";
			this->checkBoxB0_9->Size = System::Drawing::Size(29, 23);
			this->checkBoxB0_9->TabIndex = 107;
			this->checkBoxB0_9->Tag = L"8";
			this->checkBoxB0_9->Text = L"0";
			this->checkBoxB0_9->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->checkBoxB0_9->UseVisualStyleBackColor = false;
			this->checkBoxB0_9->Click += gcnew System::EventHandler(this, &Form1::checkBoxPin_CheckedChanged);
			// 
			// btnDevice
			// 
			this->btnDevice->Location = System::Drawing::Point(153, 322);
			this->btnDevice->Name = L"btnDevice";
			this->btnDevice->Size = System::Drawing::Size(170, 23);
			this->btnDevice->TabIndex = 128;
			this->btnDevice->Text = L"Device Select";
			this->btnDevice->UseVisualStyleBackColor = true;
			this->btnDevice->Click += gcnew System::EventHandler(this, &Form1::btnDevice_Click);
			// 
			// checkBox92
			// 
			this->checkBox92->Appearance = System::Windows::Forms::Appearance::Button;
			this->checkBox92->BackColor = System::Drawing::Color::Silver;
			this->checkBox92->Enabled = false;
			this->checkBox92->FlatAppearance->CheckedBackColor = System::Drawing::Color::Lime;
			this->checkBox92->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->checkBox92->Location = System::Drawing::Point(6, 295);
			this->checkBox92->Name = L"checkBox92";
			this->checkBox92->Size = System::Drawing::Size(51, 44);
			this->checkBox92->TabIndex = 127;
			this->checkBox92->Text = L"USB";
			this->checkBox92->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->checkBox92->UseVisualStyleBackColor = false;
			// 
			// checkBox91
			// 
			this->checkBox91->Appearance = System::Windows::Forms::Appearance::Button;
			this->checkBox91->BackColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(128)), static_cast<System::Int32>(static_cast<System::Byte>(255)), 
				static_cast<System::Int32>(static_cast<System::Byte>(128)));
			this->checkBox91->Enabled = false;
			this->checkBox91->FlatAppearance->CheckedBackColor = System::Drawing::Color::Lime;
			this->checkBox91->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->checkBox91->Location = System::Drawing::Point(6, 260);
			this->checkBox91->Name = L"checkBox91";
			this->checkBox91->Size = System::Drawing::Size(41, 28);
			this->checkBox91->TabIndex = 124;
			this->checkBox91->Text = L"LED";
			this->checkBox91->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->checkBox91->UseVisualStyleBackColor = false;
			// 
			// groupBox5
			// 
			this->groupBox5->Controls->Add(this->checkBox3);
			this->groupBox5->Controls->Add(this->label5);
			this->groupBox5->Controls->Add(this->checkBox4);
			this->groupBox5->Controls->Add(this->label6);
			this->groupBox5->Location = System::Drawing::Point(88, 260);
			this->groupBox5->Name = L"groupBox5";
			this->groupBox5->Size = System::Drawing::Size(302, 41);
			this->groupBox5->TabIndex = 125;
			this->groupBox5->TabStop = false;
			this->groupBox5->Text = L"Key to Pin  State";
			// 
			// label5
			// 
			this->label5->AutoSize = true;
			this->label5->Location = System::Drawing::Point(195, 17);
			this->label5->Name = L"label5";
			this->label5->Size = System::Drawing::Size(69, 13);
			this->label5->TabIndex = 2;
			this->label5->Text = L"Low (GND) : ";
			this->label5->TextAlign = System::Drawing::ContentAlignment::MiddleRight;
			// 
			// checkBox4
			// 
			this->checkBox4->Appearance = System::Windows::Forms::Appearance::Button;
			this->checkBox4->BackColor = System::Drawing::Color::Lime;
			this->checkBox4->Enabled = false;
			this->checkBox4->FlatAppearance->CheckedBackColor = System::Drawing::Color::Lime;
			this->checkBox4->FlatStyle = System::Windows::Forms::FlatStyle::Flat;
			this->checkBox4->Location = System::Drawing::Point(141, 12);
			this->checkBox4->Name = L"checkBox4";
			this->checkBox4->Size = System::Drawing::Size(29, 23);
			this->checkBox4->TabIndex = 1;
			this->checkBox4->Text = L"1";
			this->checkBox4->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			this->checkBox4->UseVisualStyleBackColor = false;
			// 
			// label6
			// 
			this->label6->AutoSize = true;
			this->label6->Location = System::Drawing::Point(86, 17);
			this->label6->Name = L"label6";
			this->label6->Size = System::Drawing::Size(57, 13);
			this->label6->TabIndex = 0;
			this->label6->Text = L"High (5V) :";
			this->label6->TextAlign = System::Drawing::ContentAlignment::MiddleRight;
			// 
			// label8
			// 
			this->label8->Location = System::Drawing::Point(458, 295);
			this->label8->Name = L"label8";
			this->label8->Size = System::Drawing::Size(190, 43);
			this->label8->TabIndex = 129;
			this->label8->Text = L"Jumper configuration and Inputs will determine specific behaviors.  Please read t" 
				L"he manual for the details.";
			// 
			// Form1
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(842, 378);
			this->Controls->Add(this->groupBox2);
			this->Controls->Add(this->btnDevice);
			this->Controls->Add(this->checkBox92);
			this->Controls->Add(this->checkBox91);
			this->Controls->Add(this->groupBox5);
			this->Controls->Add(this->label8);
			this->Name = L"Form1";
			this->Text = L"Form1";
			this->groupBox2->ResumeLayout(false);
			this->groupBox2->PerformLayout();
			this->groupBox5->ResumeLayout(false);
			this->groupBox5->PerformLayout();
			this->ResumeLayout(false);

		}
#pragma endregion

	private: 
		System::Void btnDevice_Click(System::Object^  sender, System::EventArgs^  e) 
		{
			// Just default to diOnly in this example
		}

	private: 
		System::Void btnToggle_Click(System::Object^  sender, System::EventArgs^  e) 
		{
			// Toggle Input Output Mode and update GUI state:
			
            // Need to stop the timer change board and GUI:
            myTimer->Stop(); 

            int i;
            int iOutMask = 0x00000000; // 32 bits // local copy for bit manipulations

			//Get button sender Tag (index)
			Button^ btnSender = safe_cast<Button^>(sender);			
			Int32 iTagindex = Convert::ToInt32(btnSender->Tag);
			
			// Toggle local mode value and button display state (Text):
            if (bModeInOut[iTagindex])
            {
                bModeInOut[iTagindex] = false;
                btnSender->Text = "I";
            }
            else
            {
				bModeInOut[iTagindex] = true;
                btnSender->Text = "O";
            }
            
			// Recreate new Outmask for Configure:         
            for (i = 0; i < numPorts; i++)
            {
                if (bModeInOut[i] == true)  // if output mode
                {  
                    iOutMask = iOutMask | (1 << i); // Int32
                    OutMask = (UInt32)iOutMask;
                }
            }

            unsigned char tristate = 0;
            unsigned int %rOutMask = (unsigned int) OutMask;
			unsigned int %rData = Data;

            int Status = AIOUSB::DIO_Configure(DeviceIndex, tristate, rOutMask,  rData);

            // Restart timer thread:
            myTimer->Enabled = true;

		}
			
	private: 
		System::Void checkBoxPin_CheckedChanged(System::Object^  sender, System::EventArgs^  e) 
		{
            // Need to stop the timer change board and GUI:
			myTimer->Stop();

            bool bHighLow;
            Int32 iTagindex = 0;

            // get correct checkbox get the checked state
            
            //Get sender Tag (index) and if check
            CheckBox^ chkSender = safe_cast<CheckBox^>(sender);			
			iTagindex = Convert::ToInt32(chkSender->Tag);
            bHighLow = chkSender->Checked;

            Int32 i;
            Int32 iStateMask = 0x00000000;
            unsigned char bByte = 1;

            i = (Int32)iTagindex;  // downcast

            iStateMask = ( ((int)Data) & (1 << (i)) ); // get single bit from index

            if (iStateMask != 0)
                bByte = 0;

            AIOUSB::DIO_Write1(DeviceIndex, (UInt32)i, bByte);  //byte is used like a bool
            
            // restart timer and Gui will update:
			myTimer->Enabled = true;
		}

	private: 
		 // This is the method to run when the timer is raised.
		static void TimerEventProcessor( Object^ , EventArgs^ )
		{
			myTimer->Stop();
			
			// Get data from board update display states:
            AIOUSB::DIO_ReadAll(DeviceIndex, Data);

            // Test each bit and set check state:
            for (int i = 0; i < numPins; i++)
            {
                if( (Data & ( 1 << (i) )) != 0 ) // looks complicated but efficient
                    checkStateArray[i]->Checked = true; // High Level
                else
                    checkStateArray[i]->Checked = false; // Low Level
            }

			// Restarts the timer and increments the counter.
			alarmCounter += 1;
			myTimer->Enabled = true;
		}
};
}

